import { Animatable, InterpolatorFn, ExtrapolateType, InterpolatorConfig, Interpolatable } from './types';
interface InterpolatorFactory {
    <In extends Interpolatable, Out extends Animatable>(interpolator: InterpolatorFn<In, Out>): typeof interpolator;
    <In extends Interpolatable, Out extends Animatable>(config: InterpolatorConfig<Out>): (input: number) => Animatable<Out>;
    <Out extends Animatable>(range: readonly number[], output: readonly Out[], extrapolate?: ExtrapolateType): (input: number) => Animatable<Out>;
}
export declare const createInterpolator: InterpolatorFactory;
export {};
